       IDENTIFICATION DIVISION.
       PROGRAM-ID.     pind04.
       AUTHOR.         Joel Saade.
       DATE-WRITTEN.   Setembro/1994.
      *----------------------------------------------------------------
      *  Inclusao de registros no arquivo indexado           
      *  CADCLI.DAT, criado pelo programa PIND01.CBL.        
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT  NOT  OPTIONAL 
                   cadcli        ASSIGN    "cadcli.dat"
                   ORGANIZATION  INDEXED
                   FILE          STATUS    ws-status
                   RECORD        KEY       cli-codigo
                   ACCESS        DYNAMIC.
       DATA DIVISION.
       FILE SECTION.
       FD  cadcli
           RECORD 20.
       01  reg-cadcli.
           05  cli-codigo  PIC  9(02).
           05  cli-nome    PIC  X(10).
           05  cli-fone.
             10  cli-fone1 PIC  9(04).
             10  cli-fone2 PIC  9(04).
       WORKING-STORAGE SECTION.
       01  ws-resp         PIC  X(01)  VALUE  SPACES.
       01  ws-borda1       PIC  X(80)  VALUE  ALL "".  *> Alt 223
       01  ws-borda2       PIC  X(80)  VALUE  ALL "".  *> Alt 220
       01  ws-erro1        PIC  X(23)  VALUE  "Cadastro nao encontrado".
       01  ws-msg1         PIC  X(21)  VALUE  SPACES.
       01  ws-status.
           05  ws-byte1    PIC  X(01).
           05  ws-byte2    PIC  X(01).
           05  ws-bytebin  REDEFINES  ws-byte2 PIC 9(02) COMP-X.
       01  ws-reg-cadcli.
           05  ws-cli-codigo   PIC  9(02).
           05  ws-cli-nome     PIC  X(10).
           05  ws-cli-fone.
             10  ws-cli-fone1  PIC  9(04).
             10  ws-cli-fone2  PIC  9(04).
       SCREEN SECTION.
       01  tela-cab.
           05  BLANK SCREEN.
           05  LINE 01 COL 01  FROM  ws-borda1 PIC  X(80)
                               FOREGROUND-COLOR 2.
           05  LINE 02 COL 30  VALUE " Inclusao de Clientes ".
           05  LINE 03 COL 01  FROM  ws-borda2 PIC  X(80) 
                               FOREGROUND-COLOR 2.
           05  LINE 05 COL 05  VALUE "Codigo: ".
           05  LINE 05 COL 15  TO  ws-cli-codigo  PIC  9(02) AUTO
                                   REQUIRED.
           05  LINE 07 COL 05  VALUE "Nome:   ".
           05  LINE 07 COL 15  TO  ws-cli-nome    PIC  X(10) AUTO
                                   REQUIRED.
           05  LINE 09 COL 05  VALUE "Telefone:".
           05  LINE 09 COL 19  VALUE "-".
           05  LINE 09 COL 15  TO  ws-cli-fone1   PIC  9(04) AUTO
                                   REQUIRED.           
           05  LINE 09 COL 20  TO  ws-cli-fone2   PIC  9(04) AUTO
                                   REQUIRED.
           05  LINE 22 COL 01  FROM  ws-borda1    PIC  X(80)
                               FOREGROUND-COLOR 2.
           05  LINE 24 COL 01  FROM  ws-borda2    PIC  X(80)
                               FOREGROUND-COLOR 2.
       01  tela-msg.
           05  LINE 23  COL 05  FROM  ws-msg1     PIC  X(21)
                                      FOREGROUND-COLOR 3 HIGHLIGHT.
           05  LINE 23  COL 30  VALUE "Nova inclusao? (S/N:)".
           05  LINE 23  COL + 2 TO    ws-resp     PIC  X(01) AUTO.
       01  tela-clear.
           05  BLANK SCREEN.
       PROCEDURE DIVISION.
           OPEN I-O   cadcli.
           IF   ws-status  <>  ZEROS
                DISPLAY tela-clear
                IF  ws-byte1 = "9" 
                    IF  ws-bytebin = 043
                        DISPLAY  ws-erro1  AT  1125     
                    END-IF
                ELSE
                    IF  ws-status = "35"
                        DISPLAY  ws-erro1  AT  1125
                    END-IF
                END-IF
                STOP  RUN
           END-IF.
       display-tela.
           DISPLAY tela-cab.
           ACCEPT  tela-cab.
           IF      ws-cli-codigo  =  ZEROS
                   CLOSE   cadcli
                   DISPLAY tela-clear
                   STOP    RUN
           END-IF
           WRITE reg-cadcli FROM  ws-reg-cadcli.
           IF    ws-status  =  "22" 
                 MOVE  "Cliente ja cadastrado"  TO  ws-msg1
           ELSE
                 MOVE  "Inclusao efetuada"      TO  ws-msg1 
           END-IF
           DISPLAY  tela-msg.
           ACCEPT   tela-msg.
           IF   ws-resp  = "S"  OR  "s"
                GO  display-tela
           ELSE
                CLOSE   cadcli
                DISPLAY tela-clear
                STOP    RUN
           END-IF
