       IDENTIFICATION DIVISION.
       PROGRAM-ID.     pind06.
       AUTHOR.         Joel Saade.
       DATE-WRITTEN.   Setembro/1994.
      *----------------------------------------------------------------
      *  Exclusao de registros no arquivo indexado CADCLI.DAT, criado  
      *  pelo programa PIND01.CBL. Uso dos comando READ e DELETE.      
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT  NOT  OPTIONAL 
                   cadcli        ASSIGN    "cadcli.dat"
                   ORGANIZATION  INDEXED
                   FILE          STATUS    ws-status
                   RECORD        KEY       cli-codigo
                   ACCESS        DYNAMIC.
       DATA DIVISION.
       FILE SECTION.
       FD  cadcli
           RECORD 20.
       01  reg-cadcli.
           05  cli-codigo  PIC  9(02).
           05  cli-nome    PIC  X(10).
           05  cli-fone1   PIC  9(04).
           05  cli-fone2   PIC  9(04).
       WORKING-STORAGE SECTION.
       01  ws-resp         PIC  X(01)  VALUE  SPACES.
       01  ws-borda1       PIC  X(80)  VALUE  ALL "".  *> Alt 223
       01  ws-borda2       PIC  X(80)  VALUE  ALL "".  *> Alt 220
       01  ws-erro1        PIC  X(23)  VALUE  "Cadastro nao encontrado".
       01  ws-cli-codigo   PIC  9(02).
       01  ws-chave        PIC  X(01)  VALUE  SPACES.
       01  ws-msg2         PIC  X(17).
       01  ws-msg3         PIC  X(23).
       01  ws-status.
           05  ws-byte1    PIC  X(01).
           05  ws-byte2    PIC  X(01).
           05  ws-bytebin  REDEFINES  ws-byte2 PIC 9(02) COMP-X.
       SCREEN SECTION.
       01  tela-cab.
           05  BLANK SCREEN.
           05  LINE 01 COL 01  FROM  ws-borda1      PIC  X(80)
                               FOREGROUND-COLOR 2.
           05  LINE 02 COL 30  VALUE " Exclusao de Clientes ".
           05  LINE 03 COL 01  FROM  ws-borda2      PIC  X(80) 
                               FOREGROUND-COLOR 2.
           05  LINE 05 COL 05  VALUE "Codigo: ".
           05  LINE 05 COL 15  TO    ws-cli-codigo  PIC  9(02) AUTO.
           05  LINE 22 COL 01  FROM  ws-borda1      PIC  X(80)
                               FOREGROUND-COLOR 2.
           05  LINE 24 COL 01  FROM  ws-borda2      PIC  X(80)
                               FOREGROUND-COLOR 2.
       01  tela-det.
           05  LINE 07 COL 05  VALUE "Nome:   ".
           05  LINE 07 COL 15  FROM   cli-nome   PIC  X(10).
           05  LINE 09 COL 05  VALUE "Telefone:".
           05  LINE 09 COL 19  VALUE "-".
           05  LINE 09 COL 15  FROM   cli-fone1  PIC  9(04).
           05  LINE 09 COL 20  FROM   cli-fone2  PIC  9(04).
       01  tela-msg1.
           05  LINE 23  COL 05  VALUE "Cliente nao cadastrado"
                                      FOREGROUND-COLOR 3 HIGHLIGHT.
           05  LINE 23  COL 30  VALUE "Nova exclusao? (S/N):".
           05  LINE 23  COL + 2 TO    ws-resp    PIC  X(01) AUTO.
       01  tela-msg2.
           05  LINE 23  COL 05  FROM  ws-msg2    PIC  X(17)
                                      FOREGROUND-COLOR 3 HIGHLIGHT.
           05  LINE 23  COL 30  FROM  ws-msg3    PIC  X(23).
           05  LINE 23  COL + 2 TO    ws-resp    PIC  X(01) AUTO.
       01  tela-clear.
           05  BLANK SCREEN.
       PROCEDURE DIVISION.
           OPEN I-O   cadcli.
           IF   ws-status  <>  ZEROS
                DISPLAY tela-clear
                IF  ws-byte1 = "9" 
                    IF  ws-bytebin = 043
                        DISPLAY  ws-erro1  AT  1125     
                    END-IF
                ELSE
                    IF  ws-status = "35"
                        DISPLAY  ws-erro1  AT  1125
                    END-IF
                END-IF
                STOP  RUN
           END-IF.
       display-tela.
           MOVE    SPACES  TO  ws-chave  ws-msg2  ws-msg3.
           DISPLAY tela-cab.
           ACCEPT  tela-cab.
           IF      ws-cli-codigo  =   ZEROS      
                   CLOSE   cadcli
                   DISPLAY tela-clear
                   STOP    RUN
           END-IF
           MOVE    ws-cli-codigo  TO  cli-codigo.
           READ    cadcli  KEY  cli-codigo.
           IF      ws-status  = "23" 
                   MOVE    "1"  TO  ws-chave
                   DISPLAY tela-msg1
                   ACCEPT  tela-msg1
           ELSE
                   DISPLAY tela-det
                   MOVE    "Excluir cliente? (S/N):"  TO  ws-msg3
                   DISPLAY tela-msg2
                   ACCEPT  tela-msg2
           END-IF
           IF  ws-chave  =  "1"
               IF   ws-resp  = "S"  OR  "s"
                    GO  display-tela
               ELSE
                    CLOSE   cadcli
                    DISPLAY tela-clear
                    STOP    RUN
               END-IF
           ELSE
               IF   ws-resp  = "S"  OR  "s"
                    DELETE   cadcli
                    MOVE     "Exclusao efetuada"      TO  ws-msg2
                    MOVE     "Nova exclusao? (S/N):"  TO  ws-msg3
                    DISPLAY  tela-msg2
                    ACCEPT   tela-msg2
                    IF   ws-resp  = "S"  OR  "s"
                         GO  display-tela
                    ELSE
                         CLOSE   cadcli
                         DISPLAY tela-clear
                         STOP    RUN
                    END-IF
               ELSE
                    GO  display-tela
               END-IF
           END-IF
           
