       IDENTIFICATION DIVISION.
       PROGRAM-ID.     prb01.
      *                Joel Saade. Fevereiro/1996.
      *----------------------------------------------------------------
      *  Uso de rotinas de biblioteca. Rotina CBL_CHECK_FILE_EXIST.    
      *  Verifica a existencia de um arquivo.                          
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       SPECIAL-NAMES.  DECIMAL-POINT  IS  COMMA.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       77  nome-arq          PIC  X(25)  VALUE SPACES.
       77  ws-mensag         PIC  X(23)  VALUE SPACES.
       01  det-arq.
           05  arq-size      PIC  X(08)  COMP-X.
           05  arq-data.
               10  arq-dia   PIC  X(01)  COMP-X.
               10  arq-mes   PIC  X(01)  COMP-X.
               10  arq-ano   PIC  X(02)  COMP-X.
           05  arq-horas.
               10  arq-hora  PIC  X(01)  COMP-X.
               10  arq-min   PIC  X(01)  COMP-X.
               10  arq-seg   PIC  X(01)  COMP-X.
               10  arq-cent  PIC  X(01)  COMP-X.
       01  status-code       PIC S9(04)  COMP.
       SCREEN SECTION.
       01  tela1.
           05  LINE  01  COL  01  VALUE  " ROTINAS DE BIBLIOTECA - "
               REVERSE-VIDEO  FOREGROUND-COLOR  2.
           05  LINE  01  COL  + 1 VALUE  "CBL_CHECK_FILE_EXIST "
               REVERSE-VIDEO  FOREGROUND-COLOR  2.
           05  LINE 05 COL 05   VALUE "Nome do arquivo:".
           05  LINE 05 COL 22   TO     nome-arq  PIC  X(25).
           05  LINE 25 COL 05   FROM   ws-mensag PIC  X(23).
       01  tela2.
           05  LINE 07 COL 05   VALUE "DETALHES DO ARQUIVO:".
           05  LINE 07 COL 26   FROM  nome-arq  PIC  X(25).
           05  LINE 09 COL 05   VALUE "Tamanho (em bytes):".
           05  LINE 09 COL 26   FROM  arq-size  PIC ZZ.ZZZ.ZZZ.
           05  LINE 10 COL 05   VALUE "Data:".
           05  LINE 10 COL 26   FROM  arq-dia   PIC 9(02).
           05  LINE 10 COL 28   VALUE "/".
           05  LINE 10 COL 29   FROM  arq-mes   PIC 9(02).
           05  LINE 10 COL 31   VALUE "/".
           05  LINE 10 COL 32   FROM  arq-ano   PIC 9(04).
           05  LINE 11 COL 05   VALUE "Hora:".
           05  LINE 11 COL 25   FROM  arq-hora  PIC 9(02).
           05  LINE 11 COL 27   VALUE ":".
           05  LINE 11 COL 28   FROM  arq-min   PIC 9(02).
           05  LINE 11 COL 30   VALUE ":".
           05  LINE 11 COL 31   FROM  arq-seg   PIC 9(02).
           05  LINE 11 COL 33   VALUE ".".
           05  LINE 11 COL 34   FROM  arq-cent  PIC 9(02).
       01  tela-clear.
           05  BLANK SCREEN.
       PROCEDURE DIVISION.
           DISPLAY  tela-clear.
       le-nome-arquivo.
           DISPLAY  tela1.
           MOVE     SPACES  TO ws-mensag.
           ACCEPT   tela1.
           IF  nome-arq  =  SPACES
               DISPLAY  tela-clear
               STOP  RUN
           END-IF
           CALL  "CBL_CHECK_FILE_EXIST"  USING     nome-arq det-arq
                                         RETURNING status-code.
           IF  status-code  = 0
               DISPLAY tela2
           ELSE
               MOVE "ARQUIVO NAO ENCONTRADO." TO  ws-mensag
               DISPLAY SPACES AT 0705
           END-IF 
           GO  le-nome-arquivo.
