       IDENTIFICATION DIVISION.
       PROGRAM-ID.     prb14.
      *                Joel Saade. Junho/1996.
      *----------------------------------------------------------------
      * 1) Uso de rotinas de biblioteca: CBL_AND, CBL_EQ, CBL_IMP, 
      *    CBL_OR, CBL_XOR, CBL_WRITE_SCR_N_ATTR e CBL_CLEAR_SCR.
      * 2) Manipulacao de teclas de funcao do usuario: 
      *    uso da clausula CRT STATUS.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.  CRT  STATUS  ws-accept-status.
       DATA DIVISION.
       WORKING-STORAGE SECTION. 
       77  ws-alt219   PIC  X(01)  VALUE       "".  *> Alt 219
       77  ws-opcao    PIC  X(01).
       77  ws-borda    PIC  X(21)  VALUE  ALL  "".  *> Alt 223
       77  ws-borda1   PIC  X(21)  VALUE  ALL  "".  *> Alt 220
       77  ws-linha    PIC  9(02)  VALUE  0.
       77  ws-rotina   PIC  X(08).
       77  ws-oper     PIC  X(03).
       77  ws-val1     PIC  X(01).
       77  ws-val2     PIC  X(01).
       77  ws-aux      PIC  X(01).
       77  ws-fim      PIC  X(01).  

      *--- Parametros para a rotina CBL_WRITE_SCR_N_ATTR

       77  ws-atrib    PIC  X(01)          VALUE  X"5B".
       77  ws-comp     PIC  X(02)  COMP-X  VALUE  23.
       01  ws-coord.
           05  ws-lin  PIC  X(01)  COMP-X  VALUE  2.
           05  ws-col  PIC  X(01)  COMP-X  VALUE  28.

      *--- Campo associado a clausula CRT STATUS, para detectar as
      *    teclas pressionadas

       01  ws-accept-status.
           05  ws-accept-modo  PIC  X(01).
           05  ws-accept-key1  PIC  9(02)  COMP-X.
           05  ws-accept-key2  PIC  9(02)  COMP-X.
       SCREEN SECTION.

      *--- Menu principal

       01  tela-menu.
           05  BLANK  SCREEN.
           05  FILLER      REVERSE-VIDEO  FOREGROUND-COLOR  2.
             10  LINE  01  COL  01  VALUE  
                 " MANIPULACAO DE TECLAS DE FUNCAO DO USUARIO ".
             10  LINE  01  COL  + 1 VALUE  "- CRT STATUS ".
           05  LINE  03  COL  32  VALUE  "OPERACOES LOGICAS".
           05  LINE  05  COL  30  FROM  ws-borda  PIC  X(21)
               FOREGROUND-COLOR  3.
           05  FILLER      REVERSE-VIDEO.
             10  LINE  06  COL  34  VALUE  "  F1:  AND   ".
             10  LINE  08  COL  34  VALUE  "  F2:  EQ    ".
             10  LINE  10  COL  34  VALUE  "  F3:  IMP   ".
             10  LINE  12  COL  34  VALUE  "  F4:  OR    ".
             10  LINE  14  COL  34  VALUE  "  F5:  XOR   ".
             10  LINE  16  COL  34  VALUE  "  ESC: FIM   ".
           05  LINE  17  COL  30  FROM  ws-borda1 PIC  X(21)
               FOREGROUND-COLOR  3.
           05  LINE  18  COL  35  TO  ws-opcao  PIC  X(01)  AUTO 
               PROMPT  " "  FOREGROUND-COLOR  0 BACKGROUND-COLOR  0.

      *--- Tela de entrada de dados, para todas as rotinas logicas

       01  tela-input.
           05  BLANK  SCREEN.
           05  FILLER    REVERSE-VIDEO  FOREGROUND-COLOR  2.
             10  LINE  01  COL  01  VALUE  " ROTINA DE BIBLIOTECA - ".
             10  LINE  01  COL  + 1 FROM   ws-rotina  PIC  X(08).
           05  LINE  03  COL  05  VALUE  "Digite 2 valores:".
           05  LINE  03  COL  + 2 TO    ws-val1  PIC  X(01)  AUTO.
           05  LINE  03  COL  + 3 TO    ws-val2  PIC  X(01)  AUTO.

      *--- Tela de resultado, para todas as rotinas logicas

       01  tela-result.
           05  LINE  05  COL  05  FROM  ws-val1  PIC  X(01).
           05  LINE  05  COL  + 2 FROM  ws-oper  PIC  X(03).
           05  LINE  05  COL  + 2 FROM  ws-aux   PIC  X(01).
           05  LINE  05  COL  + 2 VALUE "=".
           05  LINE  05  COL  + 2 FROM  ws-val2  PIC  X(01).

      *--- Tela de termino, para todas as rotinas logicas

       01  tela-fim.
           05  LINE  24  COL  01  VALUE  " Continuar? (S/N): "
               REVERSE-VIDEO  FOREGROUND-COLOR  3.  
           05  LINE  24  COL  + 1 TO  ws-fim  PIC  X(01)  AUTO 
               PROMPT  " "  FOREGROUND-COLOR  0 BACKGROUND-COLOR  0.
       PROCEDURE DIVISION.
           PERFORM    UNTIL  ws-accept-key1 = 0
             MOVE     "S"    TO    ws-fim
             MOVE     4      TO    ws-linha
             DISPLAY  tela-menu
             PERFORM  060-moldura  13  TIMES

      *--- Aplica o atributo "5B" a linha "OPERACOES LOGICAS"

             CALL     "CBL_WRITE_SCR_N_ATTR"  USING  ws-coord
                                                     ws-atrib
                                                     ws-comp
             ACCEPT   tela-menu
             IF   ws-accept-modo  =  "1"   
                  EVALUATE ws-accept-key1  
                    WHEN  1                 *> se tecla = F1
                        PERFORM  010-and 
                    WHEN  2                 *> se tecla = F2
                        PERFORM  020-eq 
                    WHEN  3                 *> se tecla = F3
                        PERFORM  030-imp  
                    WHEN  4                 *> se tecla = F4
                        PERFORM  040-or 
                    WHEN  5                 *> se tecla = F5
                        PERFORM  050-xor
                  END-EVALUATE
             END-IF
           END-PERFORM 

      *--- Encerramento do programa, causado pela tecla ESC

           MOVE  X"1E"            TO     ws-atrib.
           CALL  "CBL_CLEAR_SCR"  USING  ws-borda  ws-atrib.
           STOP  RUN.

      *--- Rotina acionada pela tecla F1

       010-and. 
           MOVE       "CBL_AND " TO  ws-rotina.
           MOVE       "AND"      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_AND"    USING  ws-val1  ws-val2
                                          BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Rotina acionada pela tecla F2

       020-eq. 
           MOVE       "CBL_EQ  " TO  ws-rotina.
           MOVE       "EQ "      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_EQ"   USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Rotina acionada pela tecla F3

       030-imp.
           MOVE       "CBL_IMP " TO  ws-rotina.
           MOVE       "IMP"      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_IMP"  USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Rotina acionada pela tecla F4

       040-or.
           MOVE       "CBL_OR"   TO  ws-rotina.
           MOVE       "OR "      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_OR"   USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Rotina acionada pela tecla F5 
      
       050-xor.
           MOVE       "CBL_XOR"  TO  ws-rotina.
           MOVE       "XOR"      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_XOR"  USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Rotina que faz a moldura, linhas verticais, apenas
       
       060-moldura.
           ADD     1  TO  ws-linha.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  29  WITH
                   FOREGROUND-COLOR  3.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  51  WITH
                   FOREGROUND-COLOR  3.
