       IDENTIFICATION DIVISION.
       PROGRAM-ID.     prb15.
      *                Joel Saade. Julho/1996.
      *----------------------------------------------------------------
      * 1) Uso de rotinas de biblioteca: CBL_AND, CBL_EQ, CBL_IMP, 
      *    CBL_OR, CBL_XOR, CBL_WRITE_SCR_N_ATTR, CBL_CLEAR_SCR,
      *    CBL_SET_CSR_POS.
      * 2) Manipulacao de teclas do modulo ADIS:     
      *    2.1 Uso da clausula CRT STATUS.
      *    2.2 Criacao de um menu POPUP.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.  CRT  STATUS  ws-accept-status.
       DATA DIVISION.
       WORKING-STORAGE SECTION. 
       77  ws-alt219   PIC  X(01)  VALUE       "".  *> Alt 219
       77  ws-opcao    PIC  X(01).
       77  ws-borda    PIC  X(21)  VALUE  ALL  "".  *> Alt 223
       77  ws-borda1   PIC  X(21)  VALUE  ALL  "".  *> Alt 220
       77  ws-linha    PIC  9(02)  VALUE  4.
       77  ws-rotina   PIC  X(08).
       77  ws-oper     PIC  X(03).
       77  ws-val1     PIC  X(01).
       77  ws-val2     PIC  X(01).
       77  ws-aux      PIC  X(01).
       77  ws-fim      PIC  X(01)  VALUE  "S".

      *--- Campos associados ao POPUP menu

       77  wsp-enter    PIC  X(01)          VALUE  "S".
       77  wsp-lin-sup  PIC  9(02)  COMP-X  VALUE  05.
       77  wsp-lin-inf  PIC  9(02)  COMP-X  VALUE  15.

      *--- Parametros para a rotina CBL_WRITE_SCR_N_ATTR

       77  wsp-ama-cia  PIC  X(13)          VALUE  ALL  X"3E".
       77  wsp-bra-pre  PIC  X(13)          VALUE  ALL  X"07".
       77  wsp-comp     PIC  X(02)  COMP-X  VALUE  19.

       01  wsp-coord.
           05  wsp-lin  PIC  X(01)  COMP-X  VALUE  05.
           05  wsp-col  PIC  X(01)  COMP-X  VALUE  30.
                  
      *--- Parametro para a rotina CBL_SET_CSR_POS

       01  wsp-coord255.
           05  FILLER   PIC  X(01)  COMP-X  VALUE  255.
           05  FILLER   PIC  X(01)  COMP-X  VALUE  255.
      
      *--- Fim - POPUP menu

      *--- Parametros para a rotina CBL_WRITE_SCR_N_ATTR

       01  ws-cia-bri-mag  PIC  X(01)          VALUE  X"5B".
       01  ws-comp         PIC  X(02)  COMP-X  VALUE  23.
       01  ws-coord.
           05  ws-lin      PIC  X(01)  COMP-X  VALUE  2.
           05  ws-col      PIC  X(01)  COMP-X  VALUE  28.

      *--- Campo associado a clausula CRT STATUS, para detectar as
      *    teclas pressionadas

       01  ws-accept-status.
           05  ws-accept-modo  PIC  X(01).
           05  ws-accept-key1  PIC  9(02)  COMP-X.
           05  ws-accept-key2  PIC  9(02)  COMP-X.
       SCREEN SECTION.

      *--- Menu principal

       01  tela-menu.
           05  BLANK  SCREEN.
           05  FILLER      REVERSE-VIDEO  FOREGROUND-COLOR  2.
             10  LINE  01  COL  01  VALUE  
                 " MANIPULACAO DE TECLAS DE FUNCAO DO MODULO ADIS ".
             10  LINE  01  COL  + 1 VALUE  "- CRT STATUS ".
             10  LINE  01  COL  + 1 VALUE  "- POPUP MENU ".
           05  LINE  03  COL  32  VALUE  "OPERACOES LOGICAS".
           05  LINE  05  COL  30  FROM  ws-borda  PIC  X(21)
               FOREGROUND-COLOR  3.
           05  LINE  06  COL  34  VALUE  "     AND     ".
           05  LINE  08  COL  34  VALUE  "     EQ      ".
           05  LINE  10  COL  34  VALUE  "     IMP     ".
           05  LINE  12  COL  34  VALUE  "     OR      ".
           05  LINE  14  COL  34  VALUE  "     XOR     ".
           05  LINE  16  COL  34  VALUE  "     FIM     ".
           05  LINE  17  COL  30  FROM  ws-borda1 PIC  X(21)
               FOREGROUND-COLOR  3.
           05  LINE  18  COL  35  TO  ws-opcao  PIC  X(01)  AUTO 
               PROMPT  " "  FOREGROUND-COLOR  0  BACKGROUND-COLOR  0.

      *--- Tela de entrada de dados, para todas as rotinas logicas

       01  tela-input.
           05  BLANK  SCREEN.
           05  FILLER    REVERSE-VIDEO  FOREGROUND-COLOR  2.
             10  LINE  01  COL  01  VALUE  " ROTINA DE BIBLIOTECA - ".
             10  LINE  01  COL  + 1 FROM   ws-rotina  PIC  X(08).
           05  LINE  03  COL  05  VALUE  "Digite 2 valores:".
           05  LINE  03  COL  + 2 TO    ws-val1  PIC  X(01)  AUTO.
           05  LINE  03  COL  + 3 TO    ws-val2  PIC  X(01)  AUTO.

      *--- Tela de resultado, para todas as rotinas logicas

       01  tela-result.
           05  LINE  05  COL  05  FROM  ws-val1  PIC  X(01).
           05  LINE  05  COL  + 2 FROM  ws-oper  PIC  X(03).
           05  LINE  05  COL  + 2 FROM  ws-aux   PIC  X(01).
           05  LINE  05  COL  + 2 VALUE "=".
           05  LINE  05  COL  + 2 FROM  ws-val2  PIC  X(01).

      *--- Tela de termino, para todas as rotinas logicas

       01  tela-fim.
           05  LINE  24  COL  01  VALUE  " Continuar? (S/N): "
               REVERSE-VIDEO  FOREGROUND-COLOR  3.  
           05  LINE  24  COL  + 1 TO  ws-fim  PIC  X(01)  AUTO 
               PROMPT  " "  FOREGROUND-COLOR  0  BACKGROUND-COLOR  0.

       PROCEDURE DIVISION.
           PERFORM   UNTIL  ws-accept-key1 = 0
             MOVE    "S"    TO    ws-fim
             MOVE    4      TO    ws-linha
             IF    wsp-enter  =   "S"
                   MOVE     "N"   TO     wsp-enter
                   DISPLAY  tela-menu
                   PERFORM  100-moldura  13    TIMES
                   PERFORM  010-barra-luminosa
                   CALL     "CBL_WRITE_SCR_N_ATTR" USING ws-coord
                                                         ws-cia-bri-mag
                                                         ws-comp
             END-IF
             CALL    "CBL_SET_CSR_POS"  USING  wsp-coord255
             ACCEPT  tela-menu

             IF   ws-accept-modo  =  "2"   
                  EVALUATE ws-accept-key1  
                    WHEN  5                   *> se tecla = Up arrow
                        PERFORM  020-move-bar-up
                    WHEN  6                   *> se tecla = Down arrow
                        PERFORM  030-move-bar-down
                  END-EVALUATE
             ELSE  
                  IF  ws-accept-modo  =  "0"
                    IF  ws-accept-key1  =  48
                        MOVE  "S"  TO  wsp-enter
                        IF  wsp-lin = 5
                            PERFORM  050-and
                        ELSE   
                           IF  wsp-lin = 7
                               PERFORM  060-eq
                           ELSE   
                              IF  wsp-lin = 9
                                  PERFORM  070-imp
                              ELSE  
                                 IF  wsp-lin = 11
                                     PERFORM  080-or
                                 ELSE  
                                    IF  wsp-lin = 13              
                                        PERFORM 090-xor
                                    ELSE
                                        MOVE  0      TO ws-accept-key1
                                    END-IF
                                 END-IF
                              END-IF
                           END-IF
                        END-IF
                    END-IF
                  END-IF
             END-IF
           END-PERFORM 

      *--- Encerramento do programa: opcao 6 do menu ou tecla ESC

           MOVE  SPACES           TO     ws-aux.
           CALL  "CBL_CLEAR_SCR"  USING  ws-aux  wsp-bra-pre.
           STOP  RUN.

      *--- Cria a barra luminosa no menu

       010-barra-luminosa.
           CALL  "CBL_WRITE_SCR_N_ATTR"  USING  wsp-coord
                                                wsp-ama-cia
                                                wsp-comp.

      *--- "Move" a barra luminosa para cima

       020-move-bar-up.
           PERFORM  040-limpa-bar.
           IF   wsp-lin   >   wsp-lin-sup
                SUBTRACT  2   FROM  wsp-lin 
           ELSE
                MOVE      wsp-lin-inf  TO  wsp-lin
           END-IF
           CALL     "CBL_WRITE_SCR_N_ATTR"  USING  wsp-coord
                                                   wsp-ama-cia
                                                   wsp-comp.

      *--- "Move" a barra luminosa para baixo   

       030-move-bar-down.
           PERFORM  040-limpa-bar.
           IF   wsp-lin  <  wsp-lin-inf
                ADD      2  TO  wsp-lin 
           ELSE
                MOVE     wsp-lin-sup  TO  wsp-lin
           END-IF
           CALL     "CBL_WRITE_SCR_N_ATTR"  USING  wsp-coord
                                                   wsp-ama-cia
                                                   wsp-comp.

      *--- Limpa a barra luminosa

       040-limpa-bar.
           CALL    "CBL_WRITE_SCR_N_ATTR"   USING  wsp-coord
                                                   wsp-bra-pre
                                                   wsp-comp.

      *--- Opcao 1 do menu

       050-and. 
           MOVE       "CBL_AND " TO  ws-rotina.
           MOVE       "AND"      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_AND"  USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Opcao 2 do menu

       060-eq. 
           MOVE       "CBL_EQ  " TO  ws-rotina.
           MOVE       "EQ "      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_EQ"   USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Opcao 3 do menu

       070-imp.
           MOVE       "CBL_IMP " TO  ws-rotina.
           MOVE       "IMP"      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_IMP"  USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Opcao 4 do menu

       080-or.
           MOVE       "CBL_OR"   TO  ws-rotina.
           MOVE       "OR "      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_OR"   USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Opcao 5 do menu 
      
       090-xor.
           MOVE       "CBL_XOR"  TO  ws-rotina.
           MOVE       "XOR"      TO  ws-oper.
           PERFORM    UNTIL  ws-fim  <>  "S"  AND  "s"
             DISPLAY  tela-input
             ACCEPT   tela-input
             MOVE     ws-val2    TO     ws-aux 
             CALL     "CBL_XOR"  USING  ws-val1  ws-val2
                                        BY       VALUE  1 
             DISPLAY  tela-result
             DISPLAY  tela-fim
             ACCEPT   tela-fim
           END-PERFORM.

      *--- Rotina que faz a moldura, linhas verticais, apenas
       
       100-moldura.
           ADD     1  TO  ws-linha.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  29  WITH
                   FOREGROUND-COLOR  3.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  51  WITH
                   FOREGROUND-COLOR  3.
                   
