       IDENTIFICATION DIVISION.
       PROGRAM-ID.     prb21.
      *                Joel Saade. Julho/1996.
      *----------------------------------------------------------------
      * Rotinas de biblioteca. Rotina X"AF" para manipulacao do MOUSE.
      * Funcoes internas: FACTORIAL e SQRT.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       SPECIAL-NAMES.  DECIMAL-POINT IS COMMA.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       77  ws-val1         PIC  9(01)     VALUE  0.
       77  ws-val2         PIC  9(02)     VALUE  0.
       77  ws-result       PIC  9(06)V99  VALUE  0.
       77  ws-alt219       PIC  X(01)     VALUE  "".      *> Alt 219
       77  ws-borda        PIC  X(17)     VALUE  ALL  "". *> Alt 223
       77  ws-borda1       PIC  X(17)     VALUE  ALL  "". *> Alt 220 
       77  ws-linha        PIC  9(02)     VALUE  3.
       77  ws-resp         PIC  X(01).

      *--- Parametros para a rotina X"AF"

      *--- Ativacao do driver do mouse

       01  mouse-funcao    PIC  9(02)  COMP-X  VALUE  64.
       01  mouse-uso       PIC  9(02)  COMP-X.

      *--- Habilita o mouse

       01  ativa-mouse     PIC  9(02)  COMP-X  VALUE  66.
       01  ativa-parm      PIC  9(02)  COMP-X.

      *--- Informacoes sobre a posicao e status do mouse

       01  get-mouse-info  PIC  9(02)  COMP-X  VALUE  67.
       01  mouse-info.                         
           05  mouse-col   PIC  9(04)  COMP-X.
           05  mouse-lin   PIC  9(04)  COMP-X.
           05  mouse-stat  PIC  9(04)  COMP-X.

      *--- Fazer com que o botao esquerdo do mouse atue como uma tecla
      *    de funcao do ADIS

       01  set-bit              PIC  9(02)  COMP-X  VALUE  1.
       01  adis-keys.      
           05  adis-set         PIC  9(02)  COMP-X.
           05  FILLER           PIC  X(01)          VALUE  "2".
           05  adis-pri-tecla   PIC  9(02)  COMP-X.
           05  adis-num-teclas  PIC  9(02)  COMP-X.

       SCREEN SECTION.
       01  tela1.
           05  BLANK SCREEN.
           05  LINE  01  COL  01  VALUE  " MANIPULACAO DO MOUSE "
               REVERSE-VIDEO  FOREGROUND-COLOR  2.
           05  LINE  04  COL  28  FROM  ws-borda  PIC  X(17)
               FOREGROUND-COLOR  6.
           05  LINE  05  COL  30  VALUE  "   FATORIAL   ".
           05  LINE  05  COL  30  TO  ws-resp  PIC  X(01)  AUTO 
               FOREGROUND-COLOR  0  BACKGROUND-COLOR  0.
           05  LINE  07  COL  30  VALUE  " RAIZ QUADRADA".
           05  LINE  07  COL  30  TO  ws-resp  PIC  X(01)  AUTO 
               FOREGROUND-COLOR  0  BACKGROUND-COLOR  0.
           05  LINE  09  COL  30  VALUE  "     FIM      ".
           05  LINE  09  COL  30  TO  ws-resp  PIC  X(01)  AUTO 
               FOREGROUND-COLOR  0  BACKGROUND-COLOR  0.
           05  LINE  11  COL  28  FROM  ws-borda1 PIC  X(17)
               FOREGROUND-COLOR  6.

       01  tela-erro.
           05  BLANK  SCREEN.
           05  LINE  12  COL  20  VALUE  
               " ERRO NA INICIALIZACAO DO MOUSE "
               REVERSE-VIDEO  FOREGROUND-COLOR  3.

       01  tela-fat.
           05  BLANK  SCREEN.
           05  LINE  01  COL  01  VALUE  " FATORIAL "
               REVERSE-VIDEO  FOREGROUND-COLOR  2.
           05  LINE  03  COL  05  VALUE  "Digite um numero: ".
           05  LINE  03  COL  + 1 TO ws-val1  PIC  9(01) AUTO.

       01  tela-raiz.
           05  BLANK  SCREEN.
           05  LINE  01  COL  01  VALUE  " RAIZ QUADRADA "
               REVERSE-VIDEO  FOREGROUND-COLOR  2.
           05  LINE  03  COL  05  VALUE  "Digite um numero: ".
           05  LINE  03  COL  + 1 TO ws-val2  PIC  9(02) AUTO.
       
       01  tela-res.
           05  LINE  05  COL  05  VALUE  "Resultado: ".
           05  LINE  05  COL  + 1 FROM   ws-result  PIC ZZZ.ZZZ,99.

       01  tela-fim.
           05  LINE  24  COL  05  VALUE  " Continuar?  SIM / NAO " 
               REVERSE-VIDEO  FOREGROUND-COLOR  3.
           05  LINE  24  COL  17  TO  ws-resp  PIC  X(01)  AUTO 
               FOREGROUND-COLOR  0  BACKGROUND-COLOR  0.

       01  tela-clear.
           05  BLANK  SCREEN.
       PROCEDURE DIVISION.

      *--- Ativa o driver do mouse e exibe o seu ponteiro

           MOVE  1        TO     mouse-uso.
           CALL  X"AF"    USING  mouse-funcao  mouse-uso.
           IF    mouse-funcao  EQUAL  255
                 DISPLAY  tela-erro
                 STOP     RUN.

      *--- Habilita o mouse

           CALL  X"AF"    USING  ativa-mouse  ativa-parm.

      *--- Faz com que o botao esquerdo do mouse atue como uma tecla
      *    de funcao do ADIS

           MOVE  3        TO     adis-set
           MOVE  27       TO     adis-pri-tecla 
           MOVE  1        TO     adis-num-teclas 
           CALL  X"AF"    USING  set-bit  adis-keys.

       010-show-tela.
           DISPLAY  tela1.
           MOVE     3            TO  ws-linha 
           PERFORM  070-moldura  8   TIMES.

       020-le-tela.
           ACCEPT   tela1.
           CALL     X"AF"  USING  get-mouse-info  mouse-info
           IF  mouse-lin  <> 4 AND 6 AND 8
               GO   020-le-tela.
           IF  mouse-col  < 28 OR > 43
               GO   020-le-tela.
           IF  mouse-lin  =  8
               GO   030-fim.
           IF  mouse-lin  =  4
               MOVE     "S"  TO  ws-resp
               PERFORM  040-fatorial
           ELSE
               MOVE     "S"  TO  ws-resp
               PERFORM  050-raizquad.
           GO  010-show-tela.

       030-fim.
           MOVE     0        TO     mouse-uso.
           CALL     X"AF"    USING  mouse-funcao  mouse-uso.
           DISPLAY  tela-clear.
           STOP     RUN.

       040-fatorial.
           PERFORM   UNTIL  ws-resp  <>  "S"
              DISPLAY  tela-fat 
              ACCEPT   tela-fat 
              COMPUTE  ws-result  =  FUNCTION  FACTORIAL (ws-val1)
              DISPLAY  tela-res 
              DISPLAY  tela-fim 
              ACCEPT   tela-fim 
              CALL     X"AF"  USING  get-mouse-info  mouse-info
              PERFORM  060-resposta
           END-PERFORM.

       050-raizquad.
           PERFORM   UNTIL  ws-resp  <>  "S"
              DISPLAY  tela-raiz 
              ACCEPT   tela-raiz 
              COMPUTE  ws-result  =  FUNCTION  SQRT (ws-val2) 
              DISPLAY  tela-res 
              DISPLAY  tela-fim 
              ACCEPT   tela-fim 
              CALL     X"AF"  USING  get-mouse-info  mouse-info
              PERFORM  060-resposta
           END-PERFORM.

       060-resposta.
              IF  mouse-lin  <> 23 
                  MOVE  "S"  TO  ws-resp
              ELSE
                  IF  mouse-col < 16 OR > 27
                      MOVE  "S"  TO  ws-resp
                  ELSE
                     IF  mouse-col  = 16 OR 17 OR 18 OR 19 OR 20
                         MOVE  "S"  TO  ws-resp
                     ELSE
                         MOVE  "N"  TO  ws-resp
                     END-IF
                  END-IF
              END-IF.

       070-moldura.
           ADD      1          TO  ws-linha.
           DISPLAY  ws-alt219  AT  LINE  ws-linha  COL  28  WITH
                    FOREGROUND-COLOR  6.
           DISPLAY  ws-alt219  AT  LINE  ws-linha  COL  45  WITH
                    FOREGROUND-COLOR  6.
