       IDENTIFICATION DIVISION.
       PROGRAM-ID.    psor01.
      *               Joel Saade. Maio/1996.
      *----------------------------------------------------------------
      *  Manipulacao do modulo SORT-MERGE.  
      *  Classifica o arquivo CADBOOK1.DAT em ordem ascendente pelos
      *  campos sf1-tipo e sf1-nome. Uso das opcoes USING e GIVING.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       SELECT cadbook1 ASSIGN  "cadbook1.dat"   *> arquivo a classificar
              ORGANIZATION     LINE  SEQUENTIAL.
       SELECT cadbook2 ASSIGN  "cadbook2.dat"   *> arquivo classificado
              ORGANIZATION     LINE  SEQUENTIAL.
       SELECT sortfile ASSIGN  "sortfile"       *> arquivo sort
              SORT     STATUS  ws-sortstat.
       DATA DIVISION.
       FILE SECTION.
       FD  cadbook1
           RECORD  39.
       01  reg-cadbook1.
           05  cb1-tipo  PIC  X(02).
           05  cb1-seq   PIC  9(03).
           05  cb1-nome  PIC  X(34).
       FD  cadbook2
           RECORD  39.
       01  reg-cadbook2.
           05  cb2-tipo  PIC  X(02).
           05  cb2-seq   PIC  9(03).
           05  cb2-nome  PIC  X(34).
       SD  sortfile                     *> arquivo sort em nivel SD
           RECORD  39.
       01  reg-sortfile.
           05  sf1-tipo  PIC  X(02).
           05  sf1-seq   PIC  9(03).
           05  sf1-nome  PIC  X(34).
       WORKING-STORAGE SECTION.
       77  ws-sortstat  PIC  X(02)  VALUE  SPACES.
       SCREEN SECTION.
       01  tela-clear.
           05  BLANK  SCREEN.
       PROCEDURE DIVISION.
           DISPLAY  tela-clear.
           SORT     sortfile ASCENDING  sf1-tipo sf1-nome
                    USING    cadbook1
                    GIVING   cadbook2.
           IF   ws-sortstat  <> ZEROS
                DISPLAY "SORT MAL SUCEDIDO" AT 1120 WITH HIGHLIGHT
                DISPLAY "Return Code:"      AT 1320 WITH HIGHLIGHT
                         ws-sortstat        AT 1335
           ELSE
                DISPLAY "SORT BEM SUCEDIDO" AT 1120 WITH HIGHLIGHT
           END-IF
           STOP RUN.
