       IDENTIFICATION DIVISION.
       PROGRAM-ID.    psor02.
      *               Joel Saade. Maio/1996.
      *----------------------------------------------------------------
      *  Manipulacao do modulo SORT-MERGE.  
      *  Classifica o arquivo CADBOOK1.DAT em ordem ascendente pelos
      *   campos sf1-tipo e sf1-nome.
      *  Uso das opcoes USING e OUTPUT-PROCEDURE.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       SELECT cadbook1 ASSIGN  "cadbook1.dat"   *> arquivo a classificar
              ORGANIZATION     LINE  SEQUENTIAL.
       SELECT sortfile ASSIGN  "sortfile"       *> arquivo sort
              SORT     STATUS  ws-sortstat.
       DATA DIVISION.
       FILE SECTION.
       FD  cadbook1
           RECORD  39.
       01  reg-cadbook1.
           05  cb1-tipo  PIC  X(02).
           05  cb1-seq   PIC  9(03).
           05  cb1-nome  PIC  X(34).
       SD  sortfile                     *> arquivo sort em nivel SD
           RECORD  39.
       01  reg-sortfile.
           05  sf1-tipo  PIC  X(02).
           05  sf1-seq   PIC  9(03).
           05  sf1-nome  PIC  X(34).
       WORKING-STORAGE SECTION.
       77  ws-sortstat  PIC  X(02)  VALUE  SPACES.
       77  ws-resp      PIC  X(01)  VALUE  SPACES.
       77  ws-lin       PIC  9(02)  VALUE  6.
       77  ws-borda     PIC  X(80)  VALUE  ALL  "".  *> Alt 223
       77  ws-alt219    PIC  X(01)  VALUE       "".  *> Alt 219
       77  ws-linha     PIC  9(02)  VALUE  0.
       SCREEN SECTION.
       01  tela-clear.
           05  BLANK  SCREEN.
       01  tela-cab.
           05  BLANK SCREEN.
           05  LINE 01 COL 01  FROM  ws-borda  PIC  X(80)
               FOREGROUND-COLOR 3.
           05  LINE 02 COL 29  VALUE "Listagem de Livros".
           05  LINE 03 COL 01  FROM  ws-borda  PIC  X(80)
               FOREGROUND-COLOR 3.
           05  LINE 05 COL 14  VALUE "TIPO  SEQ.       NOME DO LIVRO" 
                               FOREGROUND-COLOR 2.
           05  LINE 22 COL 01  FROM  ws-borda  PIC  X(80) 
               FOREGROUND-COLOR 3.
           05  LINE 24 COL 01  FROM  ws-borda  PIC  X(80) 
               FOREGROUND-COLOR 3.
       01  tela-det.
           05  LINE ws-lin COL 15  FROM  sf1-tipo    PIC  X(02).
           05  LINE ws-lin COL 20  FROM  sf1-seq     PIC  9(03).
           05  LINE ws-lin COL 26  FROM  sf1-nome    PIC  X(34).
       01  tela-msg1.
           05  LINE 23  COL 05  VALUE "Pressione ENTER para continuar".
           05  LINE 23  COL + 2 TO  ws-resp  PIC  X(01).
       01  tela-msg2.
           05  LINE 23  COL 05  VALUE "Pressione ENTER para encerrar".
           05  LINE 23  COL + 2 TO  ws-resp  PIC  X(01).
       PROCEDURE DIVISION.
           DISPLAY  tela-clear.
           SORT     sortfile ASCENDING  sf1-tipo sf1-nome
                    USING    cadbook1
                    OUTPUT   PROCEDURE  010-procsort  THRU
                                        099-fim-procsort.

           IF   ws-sortstat  <>  ZEROS
                DISPLAY "SORT MAL SUCEDIDO" AT 1120 WITH HIGHLIGHT
                DISPLAY "Return Code:"      AT 1320 WITH HIGHLIGHT
                         ws-sortstat        AT 1335
           END-IF
           DISPLAY  tela-msg2.
           ACCEPT   tela-msg2.
           DISPLAY  tela-clear.
           STOP RUN.

       010-procsort.
           DISPLAY tela-cab.
           PERFORM 020-moldura  23  TIMES.

       012-le-sort.
           RETURN  sortfile  END
                   GO  099-fim-procsort.
           ADD   1 TO  ws-lin.
           IF    ws-lin  >   19
                 DISPLAY tela-msg1
                 ACCEPT  tela-msg1
                 DISPLAY tela-cab
                 MOVE    ZEROS        TO  ws-linha
                 PERFORM 020-moldura  23  TIMES
                 MOVE    7   TO  ws-lin
           END-IF
           DISPLAY  tela-det.
           GO       012-le-sort.
       099-fim-procsort.

       020-moldura.
           ADD     1  TO  ws-linha.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  01  WITH
                   FOREGROUND-COLOR  3.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  80  WITH
                   FOREGROUND-COLOR  3.

