       IDENTIFICATION DIVISION.
       PROGRAM-ID.  psor04.
      *             Joel Saade. Maio/1996.
      *----------------------------------------------------------------
      *  Manipulacao do modulo SORT-MERGE.
      *  Intercala os arquivos INSORT1 e INSORT2, classificados previa-
      *  mente em ordem ascendente. Uso das opcoes USING e GIVING.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       SELECT  mergefile     ASSIGN  "mergefile"
               SORT          STATUS  ws-statsort.
       SELECT  insort1       ASSIGN  "insort1.dat"
               ORGANIZATION  LINE    SEQUENTIAL.
       SELECT  insort2       ASSIGN  "insort2.dat"
               ORGANIZATION  LINE    SEQUENTIAL.
       SELECT  intercal      ASSIGN  "intercal.dat"
               ORGANIZATION  LINE    SEQUENTIAL.
       DATA DIVISION.
       FILE SECTION.
       FD  insort1                      *> arquivo a ser intercalado
           RECORD 12.
       01  reg-insort1.
           05  in1-numero   PIC 9(02).
           05  in1-extenso  PIC X(10).
       FD  insort2                      *> arquivo a ser intercalado
           RECORD 12.
       01  reg-insort2.
           05  in2-numero   PIC 9(02).
           05  in2-extenso  PIC X(10).
       FD  intercal                     *> arquivo intercalado
           RECORD  12.
       01  REG-intercal.
           05  int-numero   PIC 9(02).
           05  int-extenso  PIC X(10).
       SD  mergefile                    *> arquivo merge em nivel SD
           RECORD 12.
       01  reg-merge.
           05  mrg-numero   PIC 9(02).
           05  mrg-extenso  PIC X(10).
       WORKING-STORAGE SECTION.
       77  ws-statsort  PIC  X(02)  VALUE  SPACES.
       SCREEN SECTION.
       01  tela-clear.
           05  BLANK  SCREEN.
       PROCEDURE DIVISION.
           DISPLAY  tela-clear.
           MERGE    mergefile  ASCENDING  mrg-numero  
                    USING      insort1    insort2
                    GIVING     intercal.
           IF  ws-statsort  NOT  =  ZEROS
               DISPLAY "MERGE MAL SUCEDIDO" AT 1120  
               DISPLAY "Return Code:"       AT 1320
                        ws-statsort         AT 1335
           END-IF
           STOP     RUN.

