       IDENTIFICATION DIVISION.
       PROGRAM-ID.    psor05.
      *               Joel Saade. Maio/1996.
      *----------------------------------------------------------------
      *  Manipulacao do modulo SORT-MERGE.  
      *  Intercala os arquivos INSORT1 e INSORT2, classificados
      *   previamente em ordem ascendente.
      *  Uso das opcoes USING e OUTPUT PROCEDURE.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       SELECT  mergefile     ASSIGN  "mergefile"
               SORT          STATUS  ws-sortstat.
       SELECT  insort1       ASSIGN  "insort1.dat"
               ORGANIZATION  LINE    SEQUENTIAL.
       SELECT  insort2       ASSIGN  "insort2.dat"
               ORGANIZATION  LINE    SEQUENTIAL.
       DATA DIVISION.
       FILE SECTION.
       FD  insort1                      *> arquivo a ser intercalado
           RECORD 12.
       01  reg-insort1.
           05  in1-numero   PIC 9(02).
           05  in1-extenso  PIC X(10).
       FD  insort2                      *> arquivo a ser intercalado
           RECORD 12.
       01  reg-insort2.
           05  in2-numero   PIC 9(02).
           05  in2-extenso  PIC X(10).
       SD  mergefile                    *> arquivo merge em nivel SD
           RECORD 12.
       01  reg-merge.
           05  mrg-numero   PIC 9(02).
           05  mrg-extenso  PIC X(10).
       WORKING-STORAGE SECTION.
       77  ws-sortstat  PIC  X(02)  VALUE  SPACES.
       77  ws-resp      PIC  X(01)  VALUE  SPACES.
       77  ws-lin       PIC  9(02)  VALUE  6.
       77  ws-borda     PIC  X(80)  VALUE  ALL  "".  *> Alt 223
       77  ws-alt219    PIC  X(01)  VALUE       "".  *> Alt 219
       77  ws-linha     PIC  9(02)  VALUE  0.
       SCREEN SECTION.
       01  tela-clear.
           05  BLANK  SCREEN.
       01  tela-cab.
           05  BLANK SCREEN.
           05  LINE 01 COL 01  FROM  ws-borda  PIC  X(80)
               FOREGROUND-COLOR 3.
           05  LINE 02 COL 25  VALUE "LISTAGEM DO ARQUIVO INTERCALADO".
           05  LINE 03 COL 01  FROM  ws-borda  PIC  X(80)
               FOREGROUND-COLOR 3.
           05  LINE 05 COL 32  VALUE "Numero  Extenso" 
                               FOREGROUND-COLOR 2.
           05  LINE 22 COL 01  FROM  ws-borda  PIC  X(80) 
               FOREGROUND-COLOR 3.
           05  LINE 24 COL 01  FROM  ws-borda  PIC  X(80) 
               FOREGROUND-COLOR 3.
       01  tela-det.
           05  LINE ws-lin COL 34  FROM  mrg-numero  PIC  9(02).
           05  LINE ws-lin COL 40  FROM  mrg-extenso PIC  X(10).
       01  tela-msg1.
           05  LINE 23  COL 05  VALUE "Pressione ENTER para continuar".
           05  LINE 23  COL + 2 TO ws-resp  PIC  X(01).
       01  tela-msg2.
           05  LINE 23  COL 05  VALUE "Pressione ENTER para encerrar".
           05  LINE 23  COL + 2 TO ws-resp  PIC  X(01).
       PROCEDURE DIVISION.
           DISPLAY  tela-clear.
           MERGE    mergefile ASCENDING  mrg-numero
                    USING     insort1    insort2
                    OUTPUT    PROCEDURE  010-procmerge THRU
                                         099-fim-procmerge.

           IF   ws-sortstat  <>  ZEROS
                DISPLAY "MERGE MAL SUCEDIDO" AT 1120 WITH HIGHLIGHT
                DISPLAY "Return Code:"       AT 1320 WITH HIGHLIGHT
                         ws-sortstat         AT 1335
           END-IF
           DISPLAY  tela-msg2.
           ACCEPT   tela-msg2.
           DISPLAY  tela-clear.
           STOP RUN.

       010-procmerge.
           DISPLAY tela-cab.
           PERFORM 020-moldura  23  TIMES.

       012-le-merge.
           RETURN  mergefile  END
                   GO  099-fim-procmerge.
           ADD   1 TO  ws-lin.
           IF    ws-lin  >   19
                 DISPLAY tela-msg1
                 ACCEPT  tela-msg1
                 DISPLAY tela-cab
                 MOVE    ZEROS        TO  ws-linha
                 PERFORM 020-moldura  23  TIMES
                 MOVE    7   TO  ws-lin
           END-IF
           DISPLAY  tela-det.
           GO       012-le-merge.
       099-fim-procmerge.

       020-moldura.
           ADD     1  TO  ws-linha.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  01  WITH
                   FOREGROUND-COLOR  3.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  80  WITH
                   FOREGROUND-COLOR  3.
                   
