       IDENTIFICATION DIVISION.
       PROGRAM-ID.     ptab03.
       AUTHOR.         Joel Saade.
       DATE-WRITTEN.   Dezembro/1994.
      *----------------------------------------------------------------
      * Carga de uma tabela unidimensional subscrita, a partir de um
      * arquivo em disco. Apos a carga, a tabela sera exibida no video.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       SELECT cadauto       ASSIGN "cadauto.dat"
	      ORGANIZATION  LINE   SEQUENTIAL.
       DATA DIVISION.
       FILE SECTION.
       FD  cadauto
	   RECORD  22.
       01  reg-cadauto.
	   05  ca-placa   PIC  X(08).
	   05  ca-marca   PIC  X(04).
	   05  ca-modelo  PIC  X(10).
       WORKING-STORAGE SECTION.
       77  sub1   PIC  9(02)  VALUE  ZEROS.  *> Subscritor
       77  lin    PIC  9(02)  VALUE  2.

      *------ Tabela de automoveis

       01  tabela.
	   05  tab-auto   OCCURS  15  TIMES.
	     10  tb-placa   PIC  X(08).
	     10  tb-marca   PIC  X(04).
	     10  tb-modelo  PIC  X(10).
       SCREEN SECTION.
       01  tela-cab.
	   05  BLANK  SCREEN.
	   05  LINE  01  COL  01  VALUE  " MANIPULACAO DE TABELAS "
	       REVERSE-VIDEO.
	   05  LINE  01  COL  + 1 VALUE  "- CARGA DE TABELA"
	       REVERSE-VIDEO.
	   05  LINE  01  COL  + 1 VALUE  " UNIDIMENSIONAL"
	       REVERSE-VIDEO.
	   05  LINE  01  COL  + 1 VALUE  " POR SUBSCRICAO "
	       REVERSE-VIDEO.
       PROCEDURE DIVISION.
	   DISPLAY  tela-cab.
	   OPEN     INPUT   cadauto.   *> Abre o arquivo cadauto

      *--- Le o arquivo cadauto, carregando-o na tabela tab-auto.
      *--- Quando ocorrer a condicao de EOF (End Of File), havera
      *--- um desvio para a rotina ler-tabauto.

       ler-cadauto.
	   READ  cadauto  AT  END
		  CLOSE    cadauto
		  MOVE     ZEROS  TO  sub1
		  GO       ler-tabauto.
      *--- Se houver mais de 15 registros no arquivo cadauto, o pro-
      *--- grama sera cancelado, pois a tabela comporta apenas 15
      *--- elementos.
	   ADD   1        TO   sub1.
	   IF    sub1     >    15
		 DISPLAY  "Programa ptab03 cancelado"       AT 1015
		 DISPLAY  "Estouro da tabela de automoveis" AT 1215
		 CLOSE    cadauto
		 STOP     RUN.
	   MOVE  ca-placa  TO tb-placa (sub1).
	   MOVE  ca-marca  TO tb-marca (sub1).
	   MOVE  ca-modelo TO tb-modelo(sub1).
	   GO    ler-cadauto.

      *--- Exibe a tabela de automoveis no video

	ler-tabauto.
	   ADD  1  TO  sub1.
	   IF   sub1  >  15
		STOP  RUN.
	   ADD  1   TO  lin.
	   DISPLAY  tb-placa (sub1) AT  LINE  lin  COLUMN 22.
	   DISPLAY  tb-marca (sub1) AT  LINE  lin  COLUMN 32.
	   DISPLAY  tb-modelo(sub1) AT  LINE  lin  COLUMN 38.
	   GO       ler-tabauto.
	   
