       IDENTIFICATION DIVISION.
       PROGRAM-ID.  ptab07.
      *             Joel Saade. Janeiro/1996.
      *----------------------------------------------------------------
      * Carga e exibicao de uma tabela dimensional, por subscricao.
      *----------------------------------------------------------------
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.  DECIMAL-POINT  COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       SELECT  softcad       ASSIGN  "softcad.dat"
               ORGANIZATION  LINE    SEQUENTIAL.
       DATA DIVISION.
       FILE SECTION.
       FD  softcad              *> arquivo a ser carregado na tabela
           RECORD  22.          *> tabsoft
       01  reg-softcad.
           05  sof-nome   PIC  X(15).
           05  sof-tipo   PIC  X(02).
           05  sof-preco  PIC  9(03)V99.
       WORKING-STORAGE SECTION.
       77  ws-sub1    PIC  9(02)  VALUE  ZEROS.
       77  ws-lin     PIC  9(02)  VALUE  6.
       77  ws-borda   PIC  X(80)  VALUE  ALL  "".  *> Alt 223
       77  ws-alt219  PIC  X(01)  VALUE       "".  *> Alt 219
       77  ws-linha   PIC  9(02)  VALUE  0.
       77  ws-resp    PIC  X(01)  VALUE  SPACES.

       01  tabsoft.
           05  nome            OCCURS  9.
             10  nome-soft  PIC  X(15).
             10  outros-dados  OCCURS  2.
               15  tipo     PIC  X(02).
               15  preco    PIC  ZZ9,99.

       SCREEN SECTION.
       01  tela-clear.
           05  BLANK  SCREEN.
       01  tela-cab.
           05  BLANK SCREEN.
           05  LINE 01 COL 01  FROM  ws-borda  PIC  X(80)
               FOREGROUND-COLOR 3.
           05  LINE 02 COL 21  VALUE 
              "CARGA/LISTAGEM DE UMA TABELA BIDIMENSIONAL".
           05  LINE 03 COL 01  FROM  ws-borda  PIC  X(80)
               FOREGROUND-COLOR 3.
           05  LINE 05 COL 25  VALUE "  SOFTWARE       TIPO   PRECO "
                                     REVERSE-VIDEO.
           05  LINE 22 COL 01  FROM  ws-borda  PIC  X(80) 
               FOREGROUND-COLOR 3.
           05  LINE 24 COL 01  FROM  ws-borda  PIC  X(80) 
               FOREGROUND-COLOR 3.
       01  tela-msg1.
           05  LINE 23  COL 05  VALUE "Pressione ENTER para encerrar"
                                      HIGHLIGHT.
           05  LINE 23  COL + 2 TO  ws-resp  PIC X(01).
       PROCEDURE DIVISION.
           OPEN     INPUT   softcad.
           DISPLAY  tela-cab.
           PERFORM  030-moldura  23  TIMES.

       010-le-softcad.                  *> Le o arquivo softcad e
           READ     softcad       END   *> monta a tabela
                    CLOSE     softcad
                    GO        020-show-tab.
           ADD      1         TO  ws-sub1.
           MOVE     sof-nome  TO  nome-soft (ws-sub1).
           MOVE     sof-tipo  TO  tipo      (ws-sub1 1).
           MOVE     sof-preco TO  preco     (ws-sub1 2).
           GO       010-le-softcad.

       020-show-tab.                    *> Exibe a tabela
           MOVE     ZEROS   TO  ws-sub1.
           PERFORM  9       TIMES
                 ADD   1    TO  ws-sub1
                 ADD   1    TO  ws-lin 
                 DISPLAY    nome-soft (ws-sub1)  
                                      AT  LINE  ws-lin  COL  25
                 DISPLAY    tipo  (ws-sub1 1)
                                      AT  LINE  ws-lin  COL  43
                 DISPLAY    preco (ws-sub1 2)
                                      AT  LINE  ws-lin  COL  49
           END-PERFORM
           DISPLAY  tela-msg1.
           ACCEPT   tela-msg1.
           DISPLAY  tela-clear.
           STOP     RUN.

       030-moldura.
           ADD     1  TO  ws-linha.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  01  WITH
                   FOREGROUND-COLOR  3.
           DISPLAY ws-alt219  AT  LINE  ws-linha  COL  80  WITH
                   FOREGROUND-COLOR  3.

